/// <reference types="./value-parser.d.ts" />
import { PrimitiveValueListNode } from '../operation-node/primitive-value-list-node.js';
import { ValueListNode } from '../operation-node/value-list-node.js';
import { ValueNode } from '../operation-node/value-node.js';
import { isReadonlyArray } from '../util/object-utils.js';
import { parseComplexExpression, isComplexExpression, } from './complex-expression-parser.js';
export function parseValueExpressionOrList(ctx, arg) {
    if (isReadonlyArray(arg)) {
        return parseValueExpressionList(ctx, arg);
    }
    else {
        return parseValueExpression(ctx, arg);
    }
}
export function parseValueExpression(ctx, exp) {
    if (isComplexExpression(exp)) {
        return parseComplexExpression(ctx, exp);
    }
    return ValueNode.create(exp);
}
function parseValueExpressionList(ctx, arg) {
    if (arg.some(isComplexExpression)) {
        return ValueListNode.create(arg.map((it) => parseValueExpression(ctx, it)));
    }
    return PrimitiveValueListNode.create(arg);
}
